/** THIS IS AN AUTOMATICALLY GENERATED FILE.  DO NOT MODIFY
 * BY HAND!!
 *
 * Generated by lcm-gen
 **/

#ifndef __drake_lcmt_drake_signal_hpp__
#define __drake_lcmt_drake_signal_hpp__

#include "lcm/lcm_coretypes.h"

#include <vector>
#include <string>

namespace drake
{

/**
 * This LCM message contains a basic vector of doubles that can represent any
 * signal passed around in Drake. Note that the channel name on which this
 * message is sent will represent the name of the overall signal.
 */
class lcmt_drake_signal
{
    public:
        /// The number of elements in the signal.
        int32_t    dim;

        /// The value of each element in the signal.
        std::vector< double > val;

        /// The name of each element in the signal.
        std::vector< std::string > coord;

        /// The timestamp in milliseconds.
        int64_t    timestamp;

    public:
        /**
         * Encode a message into binary form.
         *
         * @param buf The output buffer.
         * @param offset Encoding starts at thie byte offset into @p buf.
         * @param maxlen Maximum number of bytes to write.  This should generally be
         *  equal to getEncodedSize().
         * @return The number of bytes encoded, or <0 on error.
         */
        inline int encode(void *buf, int offset, int maxlen) const;

        /**
         * Check how many bytes are required to encode this message.
         */
        inline int getEncodedSize() const;

        /**
         * Decode a message from binary form into this instance.
         *
         * @param buf The buffer containing the encoded message.
         * @param offset The byte offset into @p buf where the encoded message starts.
         * @param maxlen The maximum number of bytes to read while decoding.
         * @return The number of bytes decoded, or <0 if an error occured.
         */
        inline int decode(const void *buf, int offset, int maxlen);

        /**
         * Retrieve the 64-bit fingerprint identifying the structure of the message.
         * Note that the fingerprint is the same for all instances of the same
         * message type, and is a fingerprint on the message type definition, not on
         * the message contents.
         */
        inline static int64_t getHash();

        /**
         * Returns "lcmt_drake_signal"
         */
        inline static const char* getTypeName();

        // LCM support functions. Users should not call these
        inline int _encodeNoHash(void *buf, int offset, int maxlen) const;
        inline int _getEncodedSizeNoHash() const;
        inline int _decodeNoHash(const void *buf, int offset, int maxlen);
        inline static uint64_t _computeHash(const __lcm_hash_ptr *p);
};

int lcmt_drake_signal::encode(void *buf, int offset, int maxlen) const
{
    int pos = 0, tlen;
    int64_t hash = getHash();

    tlen = __int64_t_encode_array(buf, offset + pos, maxlen - pos, &hash, 1);
    if(tlen < 0) return tlen; else pos += tlen;

    tlen = this->_encodeNoHash(buf, offset + pos, maxlen - pos);
    if (tlen < 0) return tlen; else pos += tlen;

    return pos;
}

int lcmt_drake_signal::decode(const void *buf, int offset, int maxlen)
{
    int pos = 0, thislen;

    int64_t msg_hash;
    thislen = __int64_t_decode_array(buf, offset + pos, maxlen - pos, &msg_hash, 1);
    if (thislen < 0) return thislen; else pos += thislen;
    if (msg_hash != getHash()) return -1;

    thislen = this->_decodeNoHash(buf, offset + pos, maxlen - pos);
    if (thislen < 0) return thislen; else pos += thislen;

    return pos;
}

int lcmt_drake_signal::getEncodedSize() const
{
    return 8 + _getEncodedSizeNoHash();
}

int64_t lcmt_drake_signal::getHash()
{
    static int64_t hash = static_cast<int64_t>(_computeHash(NULL));
    return hash;
}

const char* lcmt_drake_signal::getTypeName()
{
    return "lcmt_drake_signal";
}

int lcmt_drake_signal::_encodeNoHash(void *buf, int offset, int maxlen) const
{
    int pos = 0, tlen;

    tlen = __int32_t_encode_array(buf, offset + pos, maxlen - pos, &this->dim, 1);
    if(tlen < 0) return tlen; else pos += tlen;

    if(this->dim > 0) {
        tlen = __double_encode_array(buf, offset + pos, maxlen - pos, &this->val[0], this->dim);
        if(tlen < 0) return tlen; else pos += tlen;
    }

    for (int a0 = 0; a0 < this->dim; a0++) {
        char* __cstr = const_cast<char*>(this->coord[a0].c_str());
        tlen = __string_encode_array(
            buf, offset + pos, maxlen - pos, &__cstr, 1);
        if(tlen < 0) return tlen; else pos += tlen;
    }

    tlen = __int64_t_encode_array(buf, offset + pos, maxlen - pos, &this->timestamp, 1);
    if(tlen < 0) return tlen; else pos += tlen;

    return pos;
}

int lcmt_drake_signal::_decodeNoHash(const void *buf, int offset, int maxlen)
{
    int pos = 0, tlen;

    tlen = __int32_t_decode_array(buf, offset + pos, maxlen - pos, &this->dim, 1);
    if(tlen < 0) return tlen; else pos += tlen;

    if(this->dim) {
        this->val.resize(this->dim);
        tlen = __double_decode_array(buf, offset + pos, maxlen - pos, &this->val[0], this->dim);
        if(tlen < 0) return tlen; else pos += tlen;
    }

    try {
        this->coord.resize(this->dim);
    } catch (...) {
        return -1;
    }
    for (int a0 = 0; a0 < this->dim; a0++) {
        int32_t __elem_len;
        tlen = __int32_t_decode_array(
            buf, offset + pos, maxlen - pos, &__elem_len, 1);
        if(tlen < 0) return tlen; else pos += tlen;
        if(__elem_len > maxlen - pos) return -1;
        this->coord[a0].assign(static_cast<const char*>(buf) + offset + pos, __elem_len -  1);
        pos += __elem_len;
    }

    tlen = __int64_t_decode_array(buf, offset + pos, maxlen - pos, &this->timestamp, 1);
    if(tlen < 0) return tlen; else pos += tlen;

    return pos;
}

int lcmt_drake_signal::_getEncodedSizeNoHash() const
{
    int enc_size = 0;
    enc_size += __int32_t_encoded_array_size(NULL, 1);
    enc_size += __double_encoded_array_size(NULL, this->dim);
    for (int a0 = 0; a0 < this->dim; a0++) {
        enc_size += this->coord[a0].size() + 4 + 1;
    }
    enc_size += __int64_t_encoded_array_size(NULL, 1);
    return enc_size;
}

uint64_t lcmt_drake_signal::_computeHash(const __lcm_hash_ptr *)
{
    uint64_t hash = 0x236e73ecd6fc3932LL;
    return (hash<<1) + ((hash>>63)&1);
}

}

#endif
