/** THIS IS AN AUTOMATICALLY GENERATED FILE.  DO NOT MODIFY
 * BY HAND!!
 *
 * Generated by lcm-gen
 **/

#ifndef __drake_lcmt_hydroelastic_quadrature_per_point_data_for_viz_hpp__
#define __drake_lcmt_hydroelastic_quadrature_per_point_data_for_viz_hpp__

#include "lcm/lcm_coretypes.h"


namespace drake
{

class lcmt_hydroelastic_quadrature_per_point_data_for_viz
{
    public:
        /**
         * The quadrature point Q, as an offset vector in the world frame W, at which
         * the traction and slip velocities are evaluated.
         */
        double     p_WQ[3];

        /**
         * Denoting Point Aq as the point of Body A coincident with Q and Point Bq as
         * the point of Body B coincident with Q, calculates vr (the velocity
         * of Bq relative to Aq) and then calculates the component perpendicular to
         * the unit surface normal n̂ as vt = vr - (vr⋅n̂)n̂.
         * The resulting vector vt is expressed in the world frame W.
         */
        double     vt_BqAq_W[3];

        /**
         * The traction vector, expressed in the world frame and with units of Pa,
         * applied to Body A at Point Q (i.e., Frame A is shifted to Aq).
         */
        double     traction_Aq_W[3];

    public:
        /**
         * Encode a message into binary form.
         *
         * @param buf The output buffer.
         * @param offset Encoding starts at thie byte offset into @p buf.
         * @param maxlen Maximum number of bytes to write.  This should generally be
         *  equal to getEncodedSize().
         * @return The number of bytes encoded, or <0 on error.
         */
        inline int encode(void *buf, int offset, int maxlen) const;

        /**
         * Check how many bytes are required to encode this message.
         */
        inline int getEncodedSize() const;

        /**
         * Decode a message from binary form into this instance.
         *
         * @param buf The buffer containing the encoded message.
         * @param offset The byte offset into @p buf where the encoded message starts.
         * @param maxlen The maximum number of bytes to read while decoding.
         * @return The number of bytes decoded, or <0 if an error occured.
         */
        inline int decode(const void *buf, int offset, int maxlen);

        /**
         * Retrieve the 64-bit fingerprint identifying the structure of the message.
         * Note that the fingerprint is the same for all instances of the same
         * message type, and is a fingerprint on the message type definition, not on
         * the message contents.
         */
        inline static int64_t getHash();

        /**
         * Returns "lcmt_hydroelastic_quadrature_per_point_data_for_viz"
         */
        inline static const char* getTypeName();

        // LCM support functions. Users should not call these
        inline int _encodeNoHash(void *buf, int offset, int maxlen) const;
        inline int _getEncodedSizeNoHash() const;
        inline int _decodeNoHash(const void *buf, int offset, int maxlen);
        inline static uint64_t _computeHash(const __lcm_hash_ptr *p);
};

int lcmt_hydroelastic_quadrature_per_point_data_for_viz::encode(void *buf, int offset, int maxlen) const
{
    int pos = 0, tlen;
    int64_t hash = getHash();

    tlen = __int64_t_encode_array(buf, offset + pos, maxlen - pos, &hash, 1);
    if(tlen < 0) return tlen; else pos += tlen;

    tlen = this->_encodeNoHash(buf, offset + pos, maxlen - pos);
    if (tlen < 0) return tlen; else pos += tlen;

    return pos;
}

int lcmt_hydroelastic_quadrature_per_point_data_for_viz::decode(const void *buf, int offset, int maxlen)
{
    int pos = 0, thislen;

    int64_t msg_hash;
    thislen = __int64_t_decode_array(buf, offset + pos, maxlen - pos, &msg_hash, 1);
    if (thislen < 0) return thislen; else pos += thislen;
    if (msg_hash != getHash()) return -1;

    thislen = this->_decodeNoHash(buf, offset + pos, maxlen - pos);
    if (thislen < 0) return thislen; else pos += thislen;

    return pos;
}

int lcmt_hydroelastic_quadrature_per_point_data_for_viz::getEncodedSize() const
{
    return 8 + _getEncodedSizeNoHash();
}

int64_t lcmt_hydroelastic_quadrature_per_point_data_for_viz::getHash()
{
    static int64_t hash = static_cast<int64_t>(_computeHash(NULL));
    return hash;
}

const char* lcmt_hydroelastic_quadrature_per_point_data_for_viz::getTypeName()
{
    return "lcmt_hydroelastic_quadrature_per_point_data_for_viz";
}

int lcmt_hydroelastic_quadrature_per_point_data_for_viz::_encodeNoHash(void *buf, int offset, int maxlen) const
{
    int pos = 0, tlen;

    tlen = __double_encode_array(buf, offset + pos, maxlen - pos, &this->p_WQ[0], 3);
    if(tlen < 0) return tlen; else pos += tlen;

    tlen = __double_encode_array(buf, offset + pos, maxlen - pos, &this->vt_BqAq_W[0], 3);
    if(tlen < 0) return tlen; else pos += tlen;

    tlen = __double_encode_array(buf, offset + pos, maxlen - pos, &this->traction_Aq_W[0], 3);
    if(tlen < 0) return tlen; else pos += tlen;

    return pos;
}

int lcmt_hydroelastic_quadrature_per_point_data_for_viz::_decodeNoHash(const void *buf, int offset, int maxlen)
{
    int pos = 0, tlen;

    tlen = __double_decode_array(buf, offset + pos, maxlen - pos, &this->p_WQ[0], 3);
    if(tlen < 0) return tlen; else pos += tlen;

    tlen = __double_decode_array(buf, offset + pos, maxlen - pos, &this->vt_BqAq_W[0], 3);
    if(tlen < 0) return tlen; else pos += tlen;

    tlen = __double_decode_array(buf, offset + pos, maxlen - pos, &this->traction_Aq_W[0], 3);
    if(tlen < 0) return tlen; else pos += tlen;

    return pos;
}

int lcmt_hydroelastic_quadrature_per_point_data_for_viz::_getEncodedSizeNoHash() const
{
    int enc_size = 0;
    enc_size += __double_encoded_array_size(NULL, 3);
    enc_size += __double_encoded_array_size(NULL, 3);
    enc_size += __double_encoded_array_size(NULL, 3);
    return enc_size;
}

uint64_t lcmt_hydroelastic_quadrature_per_point_data_for_viz::_computeHash(const __lcm_hash_ptr *)
{
    uint64_t hash = 0xc093c3933c1ec1d9LL;
    return (hash<<1) + ((hash>>63)&1);
}

}

#endif
