/** THIS IS AN AUTOMATICALLY GENERATED FILE.  DO NOT MODIFY
 * BY HAND!!
 *
 * Generated by lcm-gen
 **/

#ifndef __drake_lcmt_panda_command_hpp__
#define __drake_lcmt_panda_command_hpp__

#include "lcm/lcm_coretypes.h"

#include <vector>

namespace drake
{

/**
 * Commands the desired state of a Franka Panda arm.
 *
 * The Franka Control Interface provides a number of possible modes to control
 * the arm, as described in
 *
 * https://frankaemika.github.io/docs/libfranka.html#realtime-commands
 *
 * The expected control mode is given by the control_mode_expected, below.
 *
 * The num_joint_{position,velocity,torque} size must not have multiple
 * different non-zero values.  Each one must be set to either the actual
 * number of joints (e.g., 7) or else zero.
 */
class lcmt_panda_command
{
    public:
        /// The timestamp in microseconds.
        int64_t    utime;

        /**
         * The commanded joint positions in radians.
         *
         * These values must be provided if the CONTROL_MODE_POSITION bit is set
         * within control_mode_expected.
         */
        int32_t    num_joint_position;

        std::vector< double > joint_position;

        /**
         * The commanded joint velocities in radians per second.
         *
         * These values must be provided if the CONTROL_MODE_VELOCITY bit is set
         * within control_mode_expected.
         */
        int32_t    num_joint_velocity;

        std::vector< double > joint_velocity;

        /**
         * The commanded joint torques.
         *
         * These values must be provided if the CONTROL_MODE_TORQUE bit is set
         * within control_mode_expected.
         */
        int32_t    num_joint_torque;

        std::vector< double > joint_torque;

        /**
         * Describes how the controller expects the driver to be configured.  See
         * the values for control_mode in lcmt_panda_status.
         */
        int8_t     control_mode_expected;

    public:
        /**
         * Encode a message into binary form.
         *
         * @param buf The output buffer.
         * @param offset Encoding starts at thie byte offset into @p buf.
         * @param maxlen Maximum number of bytes to write.  This should generally be
         *  equal to getEncodedSize().
         * @return The number of bytes encoded, or <0 on error.
         */
        inline int encode(void *buf, int offset, int maxlen) const;

        /**
         * Check how many bytes are required to encode this message.
         */
        inline int getEncodedSize() const;

        /**
         * Decode a message from binary form into this instance.
         *
         * @param buf The buffer containing the encoded message.
         * @param offset The byte offset into @p buf where the encoded message starts.
         * @param maxlen The maximum number of bytes to read while decoding.
         * @return The number of bytes decoded, or <0 if an error occured.
         */
        inline int decode(const void *buf, int offset, int maxlen);

        /**
         * Retrieve the 64-bit fingerprint identifying the structure of the message.
         * Note that the fingerprint is the same for all instances of the same
         * message type, and is a fingerprint on the message type definition, not on
         * the message contents.
         */
        inline static int64_t getHash();

        /**
         * Returns "lcmt_panda_command"
         */
        inline static const char* getTypeName();

        // LCM support functions. Users should not call these
        inline int _encodeNoHash(void *buf, int offset, int maxlen) const;
        inline int _getEncodedSizeNoHash() const;
        inline int _decodeNoHash(const void *buf, int offset, int maxlen);
        inline static uint64_t _computeHash(const __lcm_hash_ptr *p);
};

int lcmt_panda_command::encode(void *buf, int offset, int maxlen) const
{
    int pos = 0, tlen;
    int64_t hash = getHash();

    tlen = __int64_t_encode_array(buf, offset + pos, maxlen - pos, &hash, 1);
    if(tlen < 0) return tlen; else pos += tlen;

    tlen = this->_encodeNoHash(buf, offset + pos, maxlen - pos);
    if (tlen < 0) return tlen; else pos += tlen;

    return pos;
}

int lcmt_panda_command::decode(const void *buf, int offset, int maxlen)
{
    int pos = 0, thislen;

    int64_t msg_hash;
    thislen = __int64_t_decode_array(buf, offset + pos, maxlen - pos, &msg_hash, 1);
    if (thislen < 0) return thislen; else pos += thislen;
    if (msg_hash != getHash()) return -1;

    thislen = this->_decodeNoHash(buf, offset + pos, maxlen - pos);
    if (thislen < 0) return thislen; else pos += thislen;

    return pos;
}

int lcmt_panda_command::getEncodedSize() const
{
    return 8 + _getEncodedSizeNoHash();
}

int64_t lcmt_panda_command::getHash()
{
    static int64_t hash = static_cast<int64_t>(_computeHash(NULL));
    return hash;
}

const char* lcmt_panda_command::getTypeName()
{
    return "lcmt_panda_command";
}

int lcmt_panda_command::_encodeNoHash(void *buf, int offset, int maxlen) const
{
    int pos = 0, tlen;

    tlen = __int64_t_encode_array(buf, offset + pos, maxlen - pos, &this->utime, 1);
    if(tlen < 0) return tlen; else pos += tlen;

    tlen = __int32_t_encode_array(buf, offset + pos, maxlen - pos, &this->num_joint_position, 1);
    if(tlen < 0) return tlen; else pos += tlen;

    if(this->num_joint_position > 0) {
        tlen = __double_encode_array(buf, offset + pos, maxlen - pos, &this->joint_position[0], this->num_joint_position);
        if(tlen < 0) return tlen; else pos += tlen;
    }

    tlen = __int32_t_encode_array(buf, offset + pos, maxlen - pos, &this->num_joint_velocity, 1);
    if(tlen < 0) return tlen; else pos += tlen;

    if(this->num_joint_velocity > 0) {
        tlen = __double_encode_array(buf, offset + pos, maxlen - pos, &this->joint_velocity[0], this->num_joint_velocity);
        if(tlen < 0) return tlen; else pos += tlen;
    }

    tlen = __int32_t_encode_array(buf, offset + pos, maxlen - pos, &this->num_joint_torque, 1);
    if(tlen < 0) return tlen; else pos += tlen;

    if(this->num_joint_torque > 0) {
        tlen = __double_encode_array(buf, offset + pos, maxlen - pos, &this->joint_torque[0], this->num_joint_torque);
        if(tlen < 0) return tlen; else pos += tlen;
    }

    tlen = __int8_t_encode_array(buf, offset + pos, maxlen - pos, &this->control_mode_expected, 1);
    if(tlen < 0) return tlen; else pos += tlen;

    return pos;
}

int lcmt_panda_command::_decodeNoHash(const void *buf, int offset, int maxlen)
{
    int pos = 0, tlen;

    tlen = __int64_t_decode_array(buf, offset + pos, maxlen - pos, &this->utime, 1);
    if(tlen < 0) return tlen; else pos += tlen;

    tlen = __int32_t_decode_array(buf, offset + pos, maxlen - pos, &this->num_joint_position, 1);
    if(tlen < 0) return tlen; else pos += tlen;

    if(this->num_joint_position) {
        this->joint_position.resize(this->num_joint_position);
        tlen = __double_decode_array(buf, offset + pos, maxlen - pos, &this->joint_position[0], this->num_joint_position);
        if(tlen < 0) return tlen; else pos += tlen;
    }

    tlen = __int32_t_decode_array(buf, offset + pos, maxlen - pos, &this->num_joint_velocity, 1);
    if(tlen < 0) return tlen; else pos += tlen;

    if(this->num_joint_velocity) {
        this->joint_velocity.resize(this->num_joint_velocity);
        tlen = __double_decode_array(buf, offset + pos, maxlen - pos, &this->joint_velocity[0], this->num_joint_velocity);
        if(tlen < 0) return tlen; else pos += tlen;
    }

    tlen = __int32_t_decode_array(buf, offset + pos, maxlen - pos, &this->num_joint_torque, 1);
    if(tlen < 0) return tlen; else pos += tlen;

    if(this->num_joint_torque) {
        this->joint_torque.resize(this->num_joint_torque);
        tlen = __double_decode_array(buf, offset + pos, maxlen - pos, &this->joint_torque[0], this->num_joint_torque);
        if(tlen < 0) return tlen; else pos += tlen;
    }

    tlen = __int8_t_decode_array(buf, offset + pos, maxlen - pos, &this->control_mode_expected, 1);
    if(tlen < 0) return tlen; else pos += tlen;

    return pos;
}

int lcmt_panda_command::_getEncodedSizeNoHash() const
{
    int enc_size = 0;
    enc_size += __int64_t_encoded_array_size(NULL, 1);
    enc_size += __int32_t_encoded_array_size(NULL, 1);
    enc_size += __double_encoded_array_size(NULL, this->num_joint_position);
    enc_size += __int32_t_encoded_array_size(NULL, 1);
    enc_size += __double_encoded_array_size(NULL, this->num_joint_velocity);
    enc_size += __int32_t_encoded_array_size(NULL, 1);
    enc_size += __double_encoded_array_size(NULL, this->num_joint_torque);
    enc_size += __int8_t_encoded_array_size(NULL, 1);
    return enc_size;
}

uint64_t lcmt_panda_command::_computeHash(const __lcm_hash_ptr *)
{
    uint64_t hash = 0x7346fbbb8026ace8LL;
    return (hash<<1) + ((hash>>63)&1);
}

}

#endif
